<template>
  <div class="">
    <div class="flex items-center">
      <SearchSettings @search="search" hint="Поиск производится по названию статуса" style="width:calc(100% - 200px)" />
      <q-btn @click="addRegion" color="green" label="Добавить" icon-right="add" dense class="h-10 ml-4"/>
    </div>
    <q-spinner-gears
        v-if="!region.length"
        color="primary"
        size="8em"
        class="mx-auto mt-12"
    />

    <q-list>
      <div class="flex">
        <q-chip v-for="(item, index) in region" :key="item._id" :label="item.name">
          <q-popup-edit v-model="item.name" v-slot="scope" >
            <q-input v-model="scope.value" dense autofocus counter />
            <q-btn v-close-popup class="float-right" label="Сохранить" color="green" size="sm" @click="updateRegion(item, index, scope.value, 'name')"/>
          </q-popup-edit>

          <q-icon name="alternate_email" size="sm" class="ml-2 cursor-pointer" >
            <q-popup-edit v-model="item.email" v-slot="scope" >
              <q-input v-model="scope.value" dense autofocus counter />
              <q-btn v-close-popup class="float-right" label="Сохранить" color="green" size="sm" @click="updateRegion(item, index, scope.value, 'email')"/>
            </q-popup-edit>
          </q-icon>
          <q-icon name="delete" size="sm" class="ml-1 cursor-pointer" @click.stop="deleteRegion(item._id, index)"/>
        </q-chip>
      </div>
    </q-list>
  </div>
</template>

<script>
import api from "../../API/api";
import {ref} from "vue";
import SearchSettings from "./Search-settings.vue";
import {useDebounce} from "../../components/useDebounce";

let stringOptions = [].reduce((acc, opt) => {
  for (let i = 1; i <= 5; i++) {
    acc.push(opt + ' ' + i)
  }
  return acc
}, [])

export default {
  name: "Region-settings",
  components: {SearchSettings},
  setup () {
    const region = ref([])
    api.getRegions()
        .then(r => {
          region.value = r.data.region
          stringOptions = r.data.region
        })
    function search (value) {
      const needle = value.toLocaleString().toLocaleLowerCase()
      region.value = stringOptions.filter(v => v.name.toLocaleLowerCase().indexOf(needle) > -1)
    }
    async function addRegion () {
      const newRegion = {name: 'Новый регион', email: 'new-region@new-region.ru'}
      await api.addRegion(newRegion)
          .then(r => {
            newRegion._id = r.data._id
            region.value.unshift(newRegion)
          })
    }
    async function updateRegion (item, index, value, key) {
      key === 'name' && (region.value[index].name = value) || (region.value[index].email = value)
      await useDebounce(api.changeRegionOther({
        _id: item._id,
        name: key === 'name' && value || item.name,
        email: key === 'email' && value || item.email,
      }), 300)
    }
    async function deleteRegion (_id, index) {
      await api.deleteRegion({_id})
          .then(() => region.value.splice(index, 1))
    }
    return {
      region,
      addRegion,
      updateRegion,
      deleteRegion,
      search,
    }
  }
}
</script>

<style scoped>

</style>